openapi: 3.0.3
info:
  title: RemoteNestAPI
  version: 0.0.13
paths:
  '/guest/{_id}':
    parameters:
      - name: _id
        in: path
        required: true
        schema:
          $ref: '#/components/schemas/_id'
    get:
      description: get one guest
      responses:
        '200':
          description: guest found and returned
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GRE'
        '400':
          $ref: '#/components/responses/BadRequest'
        '404':
          $ref: '#/components/responses/NotFound'
        '500':
          $ref: '#/components/responses/ServerError'
    delete:
      description: Delete GRE (1)
      responses:
        '204':
          description: Delete one guest
        '400':
          $ref: '#/components/responses/BadRequest'
        '404':
          $ref: '#/components/responses/NotFound'
        '500':
          $ref: '#/components/responses/ServerError'
    put:
      description: Update (put) one guest (GRE collection)
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/GRE'
        required: true
      responses:
        '200':
          description: Product updated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GRE'
          headers:
            Location:
              description: URI of updated Guest.
              explode: false
              required: true
              schema:
                minLength: 1
                nullable: false
                type: string
              style: simple
        '400':
          $ref: '#/components/responses/BadRequest'
        '404':
          $ref: '#/components/responses/NotFound'
        '500':
          $ref: '#/components/responses/ServerError'
  /guest/:
    post:
      description: Create Guest (post 1)
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/GREForPOST'
        required: true
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GREForPOST'
          description: Created.
          headers:
            Location:
              description: URI of new Guest.
              explode: false
              required: true
              schema:
                minLength: 1
                nullable: false
                type: string
              style: simple
        '400':
          $ref: '#/components/responses/BadRequest'
        '500':
          $ref: '#/components/responses/ServerError'
  '/qs/{_id}':
    parameters:
      - name: _id
        in: path
        required: true
        schema:
          $ref: '#/components/schemas/_id'
    get:
      description: get one questionaire submission
      responses:
        '200':
          description: questionaaire found and returned
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/QS'
        '400':
          $ref: '#/components/responses/BadRequest'
        '404':
          $ref: '#/components/responses/NotFound'
        '500':
          $ref: '#/components/responses/ServerError'
    delete:
      description: Delete GRE (1)
      responses:
        '204':
          description: Delete one questionaire submission
        '400':
          $ref: '#/components/responses/BadRequest'
        '404':
          $ref: '#/components/responses/NotFound'
        '500':
          $ref: '#/components/responses/ServerError'
    put:
      description: Update (put) one guest (QS collection)
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/QS'
        required: true
      responses:
        '200':
          description: Product updated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/QS'
          headers:
            Location:
              description: URI of updated QS.
              explode: false
              required: true
              schema:
                minLength: 1
                nullable: false
                type: string
              style: simple
        '400':
          $ref: '#/components/responses/BadRequest'
        '404':
          $ref: '#/components/responses/NotFound'
        '500':
          $ref: '#/components/responses/ServerError'
  /qs/:
    post:
      description: Create one questionaire submission (QS) (post 1)
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/QSForPOST'
        required: true
      responses:
        '201':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/QSForPOST'
          description: Created.
          headers:
            Location:
              description: URI of new QS.
              explode: false
              required: true
              schema:
                minLength: 1
                nullable: false
                type: string
              style: simple
        '400':
          $ref: '#/components/responses/BadRequest'
        '500':
          $ref: '#/components/responses/ServerError'
components:
  responses:
    BadRequest:
      description: The request was malformed
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/EovError'
    NotFound:
      description: The specified resource was not found
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/EovError'
    ServerError:
      description: There was an error in the server.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/EovError'
  schemas:
    EovError:
      description: Not Acceptable
      type: object
      example:
        message: '.response should have required property ''name'', .response should have required property ''id'''
        errors:
          - path: .response.name
            message: should have required property 'name'
            errorCode: required.openapi.validation
          - path: .response.id
            message: should have required property 'id'
            errorCode: required.openapi.validation
      properties:
        message:
          type: string
        errors:
          type: array
          items:
            type: object
            properties:
              path:
                type: string
              message:
                type: string
              errorCode:
                type: string
    _id:
      description: Unique identifier consisting of a 24 digit hexidecimal values (a MongoDB stingified ObjectID)
      example: 0123456789aBcDeF01234567
      maxLength: 24
      minLength: 24
      nullable: false
      pattern: '^[a-zA-Z0-9]+$'
      type: string
    mongoid:
      $ref: '#/components/schemas/_id'
    GRE:
      properties:
        _id:
          $ref: '#/components/schemas/_id'
        id:
          $ref: '#/components/schemas/id'
        name:
          $ref: '#/components/schemas/name'
        phone:
          $ref: '#/components/schemas/phone'
        date:
          $ref: '#/components/schemas/date'
        address:
          $ref: '#/components/schemas/address'
        city:
          $ref: '#/components/schemas/city'
        zipcode:
          $ref: '#/components/schemas/zipcode'
        state:
          $ref: '#/components/schemas/state'
        affliction:
          $ref: '#/components/schemas/affliction'
        age:
          $ref: '#/components/schemas/age'
        gender:
          $ref: '#/components/schemas/gender'
        diet:
          $ref: '#/components/schemas/diet'
        programs:
          $ref: '#/components/schemas/programs'
        snap:
          $ref: '#/components/schemas/snap'
        employment:
          $ref: '#/components/schemas/employment'
        health:
          $ref: '#/components/schemas/health'
        housing:
          $ref: '#/components/schemas/housing'
        income:
          $ref: '#/components/schemas/income'
        householdNum:
          $ref: '#/components/schemas/householdNum'
        childcareStatus:
          $ref: '#/components/schemas/childcareStatus'
        children1:
          $ref: '#/components/schemas/children1'
        children5:
          $ref: '#/components/schemas/children5'
        children12:
          $ref: '#/components/schemas/children12'
        children18:
          $ref: '#/components/schemas/children18'
        referralInfo:
          $ref: '#/components/schemas/referralInfo'
        additionalInfo:
          $ref: '#/components/schemas/additionalInfo'
        nameOfVolunteer:
          $ref: '#/components/schemas/nameOfVolunteer'
        barcode:
          $ref: '#/components/schemas/barcode'
      required:
        - _id
        - id
        - name
        - phone
        - date
        - address
        - city
        - state
        - zipcode
        - affiliation
        - age
        - gender
        - diet
        - programs
        - snap
        - employment
        - health
        - housing
        - income
        - householdNum
        - childcareStatus
        - children1
        - children5
        - children12
        - children18
        - referralInfo
        - additionalInfo
        - nameOfVolunteer
        - barcode
      type: object
    GREForPOST:
      properties:
        id:
          $ref: '#/components/schemas/id'
        name:
          $ref: '#/components/schemas/name'
        phone:
          $ref: '#/components/schemas/phone'
        date:
          $ref: '#/components/schemas/date'
        address:
          $ref: '#/components/schemas/address'
        city:
          $ref: '#/components/schemas/city'
        zipcode:
          $ref: '#/components/schemas/zipcode'
        state:
          $ref: '#/components/schemas/state'
        affliction:
          $ref: '#/components/schemas/affliction'
        age:
          $ref: '#/components/schemas/age'
        gender:
          $ref: '#/components/schemas/gender'
        diet:
          $ref: '#/components/schemas/diet'
        programs:
          $ref: '#/components/schemas/programs'
        snap:
          $ref: '#/components/schemas/snap'
        employment:
          $ref: '#/components/schemas/employment'
        health:
          $ref: '#/components/schemas/health'
        housing:
          $ref: '#/components/schemas/housing'
        income:
          $ref: '#/components/schemas/income'
        householdNum:
          $ref: '#/components/schemas/householdNum'
        childcareStatus:
          $ref: '#/components/schemas/childcareStatus'
        children1:
          $ref: '#/components/schemas/children1'
        children5:
          $ref: '#/components/schemas/children5'
        children12:
          $ref: '#/components/schemas/children12'
        children18:
          $ref: '#/components/schemas/children18'
        referralInfo:
          $ref: '#/components/schemas/referralInfo'
        additionalInfo:
          $ref: '#/components/schemas/additionalInfo'
        nameOfVolunteer:
          $ref: '#/components/schemas/nameOfVolunteer'
        barcode:
          $ref: '#/components/schemas/barcode'
      required:
        - id
        - name
        - phone
        - date
        - address
        - city
        - state
        - zipcode
        - affiliation
        - age
        - gender
        - diet
        - programs
        - snap
        - employment
        - health
        - housing
        - income
        - householdNum
        - childcareStatus
        - children1
        - children5
        - children12
        - children18
        - referralInfo
        - additionalInfo
        - nameOfVolunteer
        - barcode
      type: object
    GREArray:
      type: array
      nullable: false
      items:
        $ref: '#/components/schemas/GRE'
    date:
      description: date
      example: date
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    name:
      description: name
      example: JDB
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    nccID:
      description: ncc id
      example: ncc id
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    phone:
      description: phone
      example: phone
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    address:
      description: address
      example: address
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    city:
      description: city
      example: city
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    zipcode:
      description: zipcode
      example: 1749
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    state:
      description: state
      example: state
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    affliction:
      description: affliction
      example: affliction
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    age:
      description: age
      example: age
      maxLength: 2048
      minLength: 1
      nullable: false
      pattern: \S+
      type: string
    gender:
      description: gender
      example: gender
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    diet:
      description: diet
      example: diet
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    programs:
      description: programs
      example: programs
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    snap:
      description: snap
      example: snap
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    employment:
      description: employment
      example: employment
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    health:
      description: health
      example: health
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    housing:
      description: housing
      example: housing
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    income:
      description: income
      example: income
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    householdNum:
      description: household number
      example: household number
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    childcareStatus:
      description: childcare status
      example: childcare status
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    children1:
      description: children 1
      example: children 1
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    children5:
      description: children 5
      example: children 5
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    children12:
      description: children 12
      example: children 12
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    children18:
      description: children 18
      example: children 18
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    referralInfo:
      description: referral info
      example: referral info
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    additionalInfo:
      description: additional information
      example: additional information
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    nameOfVolunteer:
      description: name of volunteer
      example: volunteer
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    barcode:
      description: barcode format needs to be confirmed
      example: example
      maxLength: 200
      minLength: 1
      nullable: false
      pattern: \S+
      type: string
    id:
      description: This is the _id field sent from the sqlLite database
      example: 1234567
      minimum: 1
      maximum: 5000000
      nullable: false
      type: number
    QS:
      properties:
        _id:
          $ref: '#/components/schemas/_id'
        id:
          $ref: '#/components/schemas/id'
        rowid:
          $ref: '#/components/schemas/rowid'
        guestid:
          $ref: '#/components/schemas/barcode'
        adults:
          $ref: '#/components/schemas/adults'
        seniors:
          $ref: '#/components/schemas/seniors'
        children:
          $ref: '#/components/schemas/children'
        firstvisit:
          $ref: '#/components/schemas/firstvisit'
        date:
          $ref: '#/components/schemas/date'
        visitcounter:
          $ref: '#/components/schemas/visitcounter'
      required:
        - _id
        - id
        - rowid
        - guestid
        - adults
        - seniors
        - children
        - firstvisit
        - date
        - visitcounter
      type: object
    QSForPOST:
      properties:
        id:
          $ref: '#/components/schemas/id'
        rowid:
          $ref: '#/components/schemas/rowid'
        guestid:
          $ref: '#/components/schemas/barcode'
        adults:
          $ref: '#/components/schemas/adults'
        seniors:
          $ref: '#/components/schemas/seniors'
        children:
          $ref: '#/components/schemas/children'
        firstvisit:
          $ref: '#/components/schemas/firstvisit'
        date:
          $ref: '#/components/schemas/date'
        visitcounter:
          $ref: '#/components/schemas/visitcounter'
      required:
        - id
        - rowid
        - guestid
        - adults
        - seniors
        - children
        - firstvisit
        - date
        - visitcounter
      type: object
    rowid:
      description: mongoid (_id) required for any activity to a mongo collection row except for POST
      example: 624299f662900f0008a5058c
      maxLength: 24
      minLength: 12
      nullable: false
      pattern: \S+
      type: string
    guestid:
      $ref: '#/components/schemas/barcode'
    adults:
      description: adults
      example: adults
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    seniors:
      description: seniors
      example: seniors
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    children:
      description: children
      example: children
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    firstvisit:
      description: firstvisit
      example: firstvisit
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    QSdate:
      description: date
      example: date
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
    visitcounter:
      description: visitercounter
      example: visitercounter
      maxLength: 2048
      minLength: 0
      nullable: false
      pattern: \S+
      type: string
